Note: This is a beta release of Red Hat Bugzilla 5.0. The data contained within is a snapshot of the live data so any changes you make will not be reflected in the production Bugzilla. Also email is disabled so feel free to test any aspect of the site that you want. File any problems you find or give feedback here.
Bug 957333 (quiterss) - Review Request: quiterss - Qt-based RSS/Atom aggregator
Summary: Review Request: quiterss - Qt-based RSS/Atom aggregator
Keywords:
Status: CLOSED CURRENTRELEASE
Alias: quiterss
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: All
OS: Linux
medium
medium
Target Milestone: ---
Assignee: Nobody's working on this, feel free to take it
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard: Trivial
Depends On:
Blocks: qt-reviews
TreeView+ depends on / blocked
 
Reported: 2013-04-27 09:19 UTC by Eugene A. Pivnev
Modified: 2015-02-22 13:48 UTC (History)
5 users (show)

Fixed In Version: quiterss-0.12.5-3.fc18
Doc Type: Bug Fix
Doc Text:
Clone Of:
Environment:
Last Closed: 2015-02-22 13:48:52 UTC
LotharLutz: fedora-review+
gwync: fedora-cvs+


Attachments (Terms of Use)

Comment 1 Christopher Meng 2013-04-30 02:57:55 UTC
Maybe /usr should be replaced by %{_prefix}?

But it's not a big problem.

Comment 2 Kevin Kofler 2013-04-30 15:07:43 UTC
Yes, and I'd also use qmake-qt4 rather than
`pkg-config --variable=exec_prefix QtCore`/bin/qmake

Comment 3 Eugene A. Pivnev 2013-04-30 15:12:32 UTC
(In reply to comment #2)
> Yes, and I'd also use qmake-qt4 rather than
> `pkg-config --variable=exec_prefix QtCore`/bin/qmake

This is distro-independent solution.
If I can make spec suse- or mdk-compatible - why not?

Comment 4 Eugene A. Pivnev 2013-04-30 15:15:44 UTC
(In reply to comment #2)
> Yes, and I'd also use qmake-qt4 rather than
> `pkg-config --variable=exec_prefix QtCore`/bin/qmake

And I also prefere to use pkg-config to ask who is who (and where).
Rather then hardcode package/binary names or paths :-)

Comment 5 Kevin Kofler 2013-05-04 21:35:27 UTC
> If I can make spec suse- or mdk-compatible - why not?

Because it makes the specfile much less readable.

And FWIW, /usr/bin/qmake-qt4 is where the actual binary sits in Fedora, `pkg-config --variable=exec_prefix QtCore`/bin/qmake is only a symlink. (If you want to know why: It's because of multilib. Different binaries do not cause multilib conflicts, symlinks to different places do.)

We generally frown upon cross-distro specfiles around here, it hurts specfile readability (and sometimes even guideline compliance) in many places.

Comment 6 Eugene A. Pivnev 2013-05-05 09:17:46 UTC
(In reply to comment #5)
> > If I can make spec suse- or mdk-compatible - why not?
> 
> Because it makes the specfile much less readable.
> 
> And FWIW, /usr/bin/qmake-qt4 is where the actual binary sits in Fedora,
> `pkg-config --variable=exec_prefix QtCore`/bin/qmake is only a symlink. (If
> you want to know why: It's because of multilib. Different binaries do not
> cause multilib conflicts, symlinks to different places do.)
> 
> We generally frown upon cross-distro specfiles around here, it hurts
> specfile readability (and sometimes even guideline compliance) in many
> places.

The problem is that in RH-based distros (_only_ in RH-based) Qt4's qmake is qmake-qt4.
This hack (pkg-config ...) is for RH-based only.
Ordinary spec must call qmake (or qmake-qt3 for Qt3 projects).

Comment 7 Markus Mayer 2013-05-05 11:24:28 UTC
taking this...

Comment 8 Markus Mayer 2013-05-05 12:17:59 UTC
Package Review
==============

Key:
[x] = Pass
[!] = Fail
[-] = Not applicable
[?] = Not evaluated
[ ] = Manual review needed



===== MUST items =====

C/C++:
[x]: Package does not contain kernel modules.
[x]: Package contains no static executables.
[x]: Package does not contain any libtool archives (.la)
[x]: Rpath absent or only used for internal libs.

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[!]: %build honors applicable compiler flags or justifies otherwise.
[!]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Development files must be in a -devel package
[x]: Package requires other packages for directories it uses.
[x]: Package uses nothing in %doc for runtime.
[x]: Package is not known to require ExcludeArch.
[!]: Package complies to the Packaging Guidelines
[!]: License field in the package spec file matches the actual license.
[x]: Package consistently uses macro is (instead of hard-coded directory
     names).
[!]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: update-desktop-database is invoked when required
[x]: gtk-update-icon-cache is invoked when required
[x]: Useful -debuginfo package or justification otherwise.
[-]: Large documentation must go in a -doc subpackage.
[x]: All build dependencies are listed in BuildRequires, except for any that
     are listed in the exceptions section of Packaging Guidelines.
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Each %files section contains %defattr if rpm < 4.4
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Package contains desktop file if it is a GUI application.
[x]: Package installs a %{name}.desktop using desktop-file-install if there is
     such a file.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[-]: Fully versioned dependency in subpackages, if present.
[x]: Spec file lacks Packager, Vendor, PreReq tags.
[x]: If (and only if) the source package includes the text of the license(s)
     in its own file, then that file, containing the text of the license(s)
     for the package is included in %doc.
[!]: Package use %makeinstall only when make install' ' DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package do not use a name that already exist
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as provided
     in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local
[x]: Package successfully compiles and builds into binary rpms on at least one
     supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).

===== SHOULD items =====

Generic:
[!]: Uses parallel make.
[-]: If the source package does not include license text(s) as a separate file
     from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[?]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[x]: Patches link to upstream bugs/comments/lists or are otherwise justified.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[?]: Package should compile and build into binary rpms on all supported
     architectures.
[-]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed files.
[x]: Sources can be downloaded from URI in Source: tag
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: Dist tag is present.
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: SourceX tarball generation or download is documented.
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define.

===== EXTRA items =====

Generic:
[-]: Large data in /usr/share should live in a noarch subpackage if package is
     arched.
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: quiterss-0.12.5-1.fc17.x86_64.rpm
quiterss.x86_64: W: spelling-error Summary(en_US) aggregator -> aggregation, aggregate
quiterss.x86_64: W: spelling-error %description -l en_US aggregator -> aggregation, aggregate
quiterss.x86_64: W: no-manual-page-for-binary quiterss
1 packages and 0 specfiles checked; 0 errors, 3 warnings.




Rpmlint (installed packages)
----------------------------
# rpmlint quiterss
quiterss.x86_64: W: spelling-error Summary(en_US) aggregator -> aggregation, aggregate
quiterss.x86_64: W: spelling-error %description -l en_US aggregator -> aggregation, aggregate
quiterss.x86_64: W: no-manual-page-for-binary quiterss
1 packages and 0 specfiles checked; 0 errors, 3 warnings.

Clarifications:
===============
%build honors applicable compiler flags or justifies otherwise:
I don't see how the appropriate flags are passed to make.

Package contains no bundled libraries without FPC exception:
qyursqltreeview is still used. As this is only one file, I don't insist of packing it separately.

Package complies to the Packaging Guidelines:
See http://fedoraproject.org/wiki/Packaging:ScriptletSnippets#Icon_Cache

License field in the package spec file matches the actual license:
LGPL (v2 or later): 3rdparty/qyursqltreeview/qyursqltreeview.cpp
GPL (v3 or later): src/plugins/clicktoflash.cpp

Package is named according to the Package Naming Guidelines:
The upstream project name is QuiteRSS!

Package use %makeinstall only when make install' ' DESTDIR=... doesn't work:
Does the other way really not work?

Uses parallel make:
Please pass %{?_smp_mflags} to make

Comment 9 Kevin Kofler 2013-05-05 13:41:54 UTC
> The problem is that in RH-based distros (_only_ in RH-based) Qt4's qmake is
> qmake-qt4.

… as it should be. Debian had been shipping it that way too until they decided to drop Qt 3 (at which point they renamed the executables, a silly incompatible change which will only cause problems again with Qt 5).

> This hack (pkg-config ...) is for RH-based only.
> Ordinary spec must call qmake (or qmake-qt3 for Qt3 projects).

An ordinary Fedora spec must call qmake-qt4 (or qmake for Qt 3 projects, or qmake-qt5 for Qt 5 projects). Anything else is an ugly hack and goes against the "spec must be readable" requirement of the packaging guidelines.

Comment 10 Christopher Meng 2013-05-05 15:06:32 UTC
(In reply to comment #6)

Don't use anything you think it's "OK".

In fact your spec is not readable for Fedora but in OBS it can works well.

So I hope you can adopt our suggestion.

Comment 11 Eugene A. Pivnev 2013-05-05 15:09:54 UTC
(In reply to comment #8)
> Clarifications:
> ===============
> %build honors applicable compiler flags or justifies otherwise:
> I don't see how the appropriate flags are passed to make.

qmake do this.
Compare:
1. rpm --eval %optflags
-O2 -g -pipe -Wall -Wp,-D_FORTIFY_SOURCE=2 -fexceptions -fstack-protector --param=ssp-buffer-size=4  -m32 -march=i686 -mtune=atom -fasynchronous-unwind-tables
2. qmake-qt4 && grep ^CXXFLAGS Makefile.Release
CXXFLAGS      = -pipe -O2 -g -pipe -Wall -Wp,-D_FORTIFY_SOURCE=2 -fstack-protector --param=ssp-buffer-size=4 -m32 -march=i686 -mtune=atom -fasynchronous-unwind-tables -O2 -Wall -W -D_REENTRANT $(DEFINES)

> Package contains no bundled libraries without FPC exception:
> qyursqltreeview is still used. As this is only one file, I don't insist of
> packing it separately.

Fedora has no qyursqltreeview in repos:
https://apps.fedoraproject.org/packages/s/qyursqltreeview
So - this is simple statically linked 3rd party.

> Package complies to the Packaging Guidelines:
> See http://fedoraproject.org/wiki/Packaging:ScriptletSnippets#Icon_Cache

See %postun, %posttrans and Requires: hicolor-icon-theme.

> License field in the package spec file matches the actual license:
> LGPL (v2 or later): 3rdparty/qyursqltreeview/qyursqltreeview.cpp
> GPL (v3 or later): src/plugins/clicktoflash.cpp

Yes, you are right.
As LGPL is compatible with GPL (https://fedoraproject.org/wiki/Licensing:Main?rd=Licensing#GPL_Compatibility_Matrix) I will set License to GPLv3+.

> Package is named according to the Package Naming Guidelines:
> The upstream project name is QuiteRSS!

Don't mix _application_ name with _package_ one:
VLC > vlc
MPlayer > mplayer
Qt4 > qt
Fedora > fedora-release

> Package use %makeinstall only when make install' ' DESTDIR=... doesn't work:
> Does the other way really not work?

Really.
Unlike other build systems (like cmake) qmake uses INSTALL_ROOT instead of DESTDIR.

> Uses parallel make:
> Please pass %{?_smp_mflags} to make
Oops, you are right #2.

So - I found 3 things to correct: license, smp_flags and qmake-qt4 (ok, ok! :-).

Comment 12 Eugene A. Pivnev 2013-05-05 15:16:28 UTC
(In reply to comment #11)
> (In reply to comment #8)
> > License field in the package spec file matches the actual license:
> > LGPL (v2 or later): 3rdparty/qyursqltreeview/qyursqltreeview.cpp
> > GPL (v3 or later): src/plugins/clicktoflash.cpp
> 
> Yes, you are right.
> As LGPL is compatible with GPL
> (https://fedoraproject.org/wiki/Licensing:
> Main?rd=Licensing#GPL_Compatibility_Matrix) I will set License to GPLv3+.

Oops, sorry - quiterss is already GPLv3.
-1

Comment 13 Eugene A. Pivnev 2013-05-05 15:33:21 UTC
* smp_flags added
* pkgconfig ... replaced with qmake-qt4

Spec URL: http://tieugene.fedorapeople.org/rpms/quiterss/quiterss.spec
SRPM URL: http://tieugene.fedorapeople.org/rpms/quiterss/quiterss-0.12.5-2.fc18.src.rpm

Comment 14 Kevin Kofler 2013-05-05 15:42:48 UTC
> Fedora has no qyursqltreeview in repos:
> https://apps.fedoraproject.org/packages/s/qyursqltreeview

That just means that you should package it.

Comment 15 Eugene A. Pivnev 2013-05-05 16:00:07 UTC
(In reply to comment #14)
> > Fedora has no qyursqltreeview in repos:
> > https://apps.fedoraproject.org/packages/s/qyursqltreeview
> 
> That just means that you should package it.

qyursqltreeview has no home page nor SCM.
Seems quiterss uses patched/updated/modified source.

Comment 16 Markus Mayer 2013-05-05 19:24:34 UTC
(In reply to comment #11)
> (In reply to comment #8)
> > Clarifications:
> > ===============
> > %build honors applicable compiler flags or justifies otherwise:
> > I don't see how the appropriate flags are passed to make.
> 
> qmake do this.
> Compare:
> 1. rpm --eval %optflags
> -O2 -g -pipe -Wall -Wp,-D_FORTIFY_SOURCE=2 -fexceptions -fstack-protector
> --param=ssp-buffer-size=4  -m32 -march=i686 -mtune=atom
> -fasynchronous-unwind-tables
> 2. qmake-qt4 && grep ^CXXFLAGS Makefile.Release
> CXXFLAGS      = -pipe -O2 -g -pipe -Wall -Wp,-D_FORTIFY_SOURCE=2
> -fstack-protector --param=ssp-buffer-size=4 -m32 -march=i686 -mtune=atom
> -fasynchronous-unwind-tables -O2 -Wall -W -D_REENTRANT $(DEFINES)
> 
Yes, you are right. A wasn't aware of this fact.

> > Package contains no bundled libraries without FPC exception:
> > qyursqltreeview is still used. As this is only one file, I don't insist of
> > packing it separately.
> 
> Fedora has no qyursqltreeview in repos:
> https://apps.fedoraproject.org/packages/s/qyursqltreeview
> So - this is simple statically linked 3rd party.
> 
As Kevin stated, packaging it would be the best solution. But I am fine with bundling it

> > Package complies to the Packaging Guidelines:
> > See http://fedoraproject.org/wiki/Packaging:ScriptletSnippets#Icon_Cache
> 
> See %postun, %posttrans and Requires: hicolor-icon-theme.
> 
The proposed scriptlets are:
%post
/bin/touch --no-create %{_datadir}/icons/hicolor &>/dev/null || :

%postun
if [ $1 -eq 0 ] ; then
    /bin/touch --no-create %{_datadir}/icons/hicolor &>/dev/null
    /usr/bin/gtk-update-icon-cache %{_datadir}/icons/hicolor &>/dev/null || :
fi

%posttrans
/usr/bin/gtk-update-icon-cache %{_datadir}/icons/hicolor &>/dev/null || :

I have only found 'BuildRequires: hicolor-icon-theme'.

> > License field in the package spec file matches the actual license:
> > LGPL (v2 or later): 3rdparty/qyursqltreeview/qyursqltreeview.cpp
> > GPL (v3 or later): src/plugins/clicktoflash.cpp
> 
> Yes, you are right.
> As LGPL is compatible with GPL
> (https://fedoraproject.org/wiki/Licensing:
> Main?rd=Licensing#GPL_Compatibility_Matrix) I will set License to GPLv3+.
> 
> > Package is named according to the Package Naming Guidelines:
> > The upstream project name is QuiteRSS!
> 
> Don't mix _application_ name with _package_ one:
> VLC > vlc
> MPlayer > mplayer
> Qt4 > qt
> Fedora > fedora-release
> 
Well, I have found QuiteRSS and quite-rss on their project site, but not quiterss. As I don't see any reason not using one of them, I would stick to the guideline.
> > Package use %makeinstall only when make install' ' DESTDIR=... doesn't work:
> > Does the other way really not work?
> 
> Really.
> Unlike other build systems (like cmake) qmake uses INSTALL_ROOT instead of
> DESTDIR.
>  
I see you don't use %makeinstall anymore. Your current way is perfectly right.
> > Uses parallel make:
> > Please pass %{?_smp_mflags} to make
> Oops, you are right #2.
> 
> So - I found 3 things to correct: license, smp_flags and qmake-qt4 (ok, ok!
> :-).

As stated above, I am not quite happy with the naming and the scriptlet. Except these two, there are no other issues.

Comment 17 Eugene A. Pivnev 2013-05-07 06:13:10 UTC
(In reply to comment #16)
> (In reply to comment #11)
> > (In reply to comment #8)
> As Kevin stated, packaging it would be the best solution. But I am fine with
> bundling it

As this snippet will be real project (with home page, versions, SCM) - I'll create it as library.

> The proposed scriptlets are:

Fixed.

> Well, I have found QuiteRSS and quite-rss on their project site, but not
> quiterss. As I don't see any reason not using one of them, I would stick to
> the guideline.

From one side - both of QuiteRSS developers are Windows users. So - they don't consider letter case. Really. Some times ago they renamed Linux binary to lowercase (for my proposition) - as lowecase is ordinay in Linux world. I can ask him to make lowercase tarball, if it is so important (but they will be displeased - Windows users like CamelCase Style).
From other side - Guidelines say "should match the upstream tarball or project name" - but not "... _exactly_ with their letter cases".

Spec URL: http://tieugene.fedorapeople.org/rpms/quiterss/quiterss.spec
SRPM URL: http://tieugene.fedorapeople.org/rpms/quiterss/quiterss-0.12.5-3.fc18.src.rpm

Comment 18 Markus Mayer 2013-05-07 08:17:02 UTC
(In reply to comment #17)
> (In reply to comment #16)
> > (In reply to comment #11)
> > > (In reply to comment #8)
> > As Kevin stated, packaging it would be the best solution. But I am fine with
> > bundling it
> 
> As this snippet will be real project (with home page, versions, SCM) - I'll
> create it as library.
> 
> > The proposed scriptlets are:
> 
> Fixed.
> 
> > Well, I have found QuiteRSS and quite-rss on their project site, but not
> > quiterss. As I don't see any reason not using one of them, I would stick to
> > the guideline.
> 
> From one side - both of QuiteRSS developers are Windows users. So - they
> don't consider letter case. Really. Some times ago they renamed Linux binary
> to lowercase (for my proposition) - as lowecase is ordinay in Linux world. I
> can ask him to make lowercase tarball, if it is so important (but they will
> be displeased - Windows users like CamelCase Style).
> From other side - Guidelines say "should match the upstream tarball or
> project name" - but not "... _exactly_ with their letter cases".
> 
> Spec URL: http://tieugene.fedorapeople.org/rpms/quiterss/quiterss.spec
> SRPM URL:
> http://tieugene.fedorapeople.org/rpms/quiterss/quiterss-0.12.5-3.fc18.src.rpm

Ok, look fine now. Finally you convinced me about the naming. (Sorry for beeing such a bullhead).

This package is APPROVED.

Comment 19 Eugene A. Pivnev 2013-05-07 08:30:34 UTC
New Package SCM Request
=======================
Package Name: quiterss
Short Description: Qt-based RSS/Atom aggregator
Owners: tieugene
Branches: f17 f18 f19
InitialCC:

Comment 20 Eugene A. Pivnev 2013-05-07 08:31:59 UTC
(In reply to comment #18)
> (In reply to comment #17)
> > (In reply to comment #16)
> > > (In reply to comment #11)
> > > > (In reply to comment #8)
> Ok, look fine now. Finally you convinced me about the naming. (Sorry for
> beeing such a bullhead).

This is your job - not? :-)

> This package is APPROVED.

Thank you!

Comment 21 Gwyn Ciesla 2013-05-07 13:12:11 UTC
Git done (by process-git-requests).

Comment 22 Fedora Update System 2013-05-07 21:50:04 UTC
quiterss-0.12.5-3.fc18 has been submitted as an update for Fedora 18.
https://admin.fedoraproject.org/updates/quiterss-0.12.5-3.fc18

Comment 23 Fedora Update System 2013-05-07 21:51:10 UTC
quiterss-0.12.5-3.fc19 has been submitted as an update for Fedora 19.
https://admin.fedoraproject.org/updates/quiterss-0.12.5-3.fc19

Comment 24 Fedora Update System 2013-05-08 19:43:01 UTC
quiterss-0.12.5-3.fc19 has been pushed to the Fedora 19 testing repository.

Comment 25 Fedora Update System 2013-05-14 04:40:06 UTC
quiterss-0.12.5-3.fc19 has been pushed to the Fedora 19 stable repository.

Comment 26 Fedora Update System 2013-05-17 03:24:51 UTC
quiterss-0.12.5-3.fc18 has been pushed to the Fedora 18 stable repository.

Comment 27 Eugene A. Pivnev 2014-09-23 07:30:14 UTC
Package Change Request
======================
Package Name: quiterss
New Branches: epel7
Owners: tieugene

Comment 28 Gwyn Ciesla 2014-09-23 12:12:50 UTC
Git done (by process-git-requests).


Note You need to log in before you can comment on or make changes to this bug.